Imports System.Data.OleDb
Public Class Form1
    Dim WithEvents myComPort As New System.IO.Ports.SerialPort
    Dim data As String
    Dim cn As OleDbConnection
    Dim cmd As OleDbCommand
    Dim dr As OleDbDataReader
    Dim icount As Integer
    Dim str As String

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        ComboBox1.Enabled = True
        Button2.Enabled = False
        Button1.Enabled = True
        RadioButton1.Enabled = False
        RadioButton2.Checked = True
        myComPort.Close()
    End Sub

    Private Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click
        If Not ComboBox1.SelectedItem Is Nothing Then
            If Not myComPort.IsOpen Then
                Try
                    myComPort.BaudRate = 2400
                    myComPort.PortName = ComboBox1.SelectedItem
                    myComPort.Parity = IO.Ports.Parity.None
                    myComPort.DataBits = 8
                    myComPort.StopBits = IO.Ports.StopBits.One
                    myComPort.Handshake = IO.Ports.Handshake.None
                    myComPort.ReadTimeout = 3000
                    myComPort.ReceivedBytesThreshold = 1
                    myComPort.DtrEnable = True

                    myComPort.Open()

                    ComboBox1.Enabled = False
                    Button1.Enabled = False
                    Button2.Enabled = True
                    RadioButton1.Enabled = True
                    RadioButton1.Checked = True

                Catch ex As Exception
                    MsgBox("Error Opening COM Port", MsgBoxStyle.Critical)
                End Try
            End If
        Else
            MsgBox("Select a valid COM Port", MsgBoxStyle.Information)
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        For Each portName As String In My.Computer.Ports.SerialPortNames
            ComboBox1.Items.Add(portName)
        Next
        CheckBox1.Checked = True
        If Not myComPort.IsOpen Then
            Button2.Enabled = False
            ComboBox1.Text = ComboBox1.Items(0)
            RadioButton1.Enabled = False
            RadioButton2.Checked = True
        Else
            Button1.Enabled = False
            ComboBox1.Text = myComPort.PortName
            RadioButton2.Checked = True
        End If

        Try
            cn = New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + RFID_Reader.My.Application.Info.DirectoryPath() + "/log.mdb;Persist Security Info=False")
            'provider to be used when working with access database
            cn.Open()
            cmd = New OleDbCommand("select * from table1", cn)
            dr = cmd.ExecuteReader
            Dim gr As Integer
            While dr.Read()
                gr = grid.Rows.Add()
                grid.Rows.Item(gr).Cells.Item(0).Value = dr(1)
                grid.Rows.Item(gr).Cells.Item(1).Value = dr(2)
                grid.Rows.Item(gr).Cells.Item(2).Value = dr(3)
                grid.Rows.Item(gr).Cells.Item(3).Value = dr(4)
                ' loading data into TextBoxes by column index
            End While
            dr.Close()
            cn.Close()
        Catch
        End Try
    End Sub

    Private Sub RadioButton1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton1.CheckedChanged
        myComPort.DtrEnable = True
    End Sub

    Private Sub RadioButton2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton2.CheckedChanged
        myComPort.DtrEnable = False
    End Sub
    Private Sub DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles myComPort.DataReceived
        grid.Invoke(New myDelegate(AddressOf updateTextBox), New Object() {})
    End Sub
    Public Delegate Sub myDelegate()
    Public Sub updateTextBox()

        data = data + myComPort.ReadExisting()
        If Len(data) = 12 Then
            Dim i As Integer
            Dim newdata As Boolean = True
            For i = 0 To (grid.Rows.Count - 1)
                If grid.Rows.Item(i).Cells(0).Value = Microsoft.VisualBasic.Mid(data, 2, 11) Then
                    newdata = False
                    Exit For
                Else
                    newdata = True
                End If
            Next
            If newdata = True Then
                Dim gr As Integer
                gr = grid.Rows.Add()
                grid.Rows.Item(gr).Cells.Item(0).Value = Microsoft.VisualBasic.Mid(data, 2, 11)
                grid.Rows.Item(gr).Cells.Item(3).Value = DateString() + " " + TimeString()
                notify.BalloonTipTitle = "New Tag"
                notify.BalloonTipText = Microsoft.VisualBasic.Mid(data, 2, 11)
                notify.ShowBalloonTip(2000)

                Try
                    cn = New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + RFID_Reader.My.Application.Info.DirectoryPath() + "/log.mdb;Persist Security Info=False")
                    cn.Open()

                    str = "insert into table1 (Tag, L_Scan) values('" & grid.Rows.Item(grid.RowCount() - 1).Cells.Item(0).Value & " ','" & grid.Rows.Item(grid.RowCount() - 1).Cells.Item(3).Value & "')"
                    'string stores the command and CInt is used to convert number to string
                    cmd = New OleDbCommand(str, cn)
                    icount = cmd.ExecuteNonQuery
                    'MessageBox.Show(icount)
                    'displays number of records inserted
                Catch e2 As Exception
                    MessageBox.Show(e2.ToString)
                End Try
                cn.Close()

            Else
                grid.Rows.Item(i).Cells.Item(3).Value = DateString() + " " + TimeString()
                grid.Rows.Item(i).Selected = True
                notify.BalloonTipTitle = "Tag Scanned"
                notify.BalloonTipText = Microsoft.VisualBasic.Mid(data, 2, 11)
                notify.ShowBalloonTip(2000)

                Try
                    cn = New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + RFID_Reader.My.Application.Info.DirectoryPath() + "/log.mdb;Persist Security Info=False")
                    cn.Open()

                    str = "update table1 SET L_Scan = '" & grid.Rows.Item(i).Cells.Item(3).Value & "' where Tag = '" & grid.Rows.Item(i).Cells.Item(0).Value & "'"
                    'string stores the command and CInt is used to convert number to string
                    cmd = New OleDbCommand(str, cn)
                    icount = cmd.ExecuteNonQuery
                    'MessageBox.Show(icount)
                    'displays number of records inserted
                Catch e2 As Exception
                    MessageBox.Show(e2.ToString)
                End Try
                cn.Close()

            End If
            myComPort.DtrEnable = False
            RadioButton1.Enabled = False
            RadioButton2.Checked = True

            If CheckBox1.Checked = True Then
                Beep()
            End If

            Dim timeOut As DateTimeOffset = Now.AddMilliseconds(1500)
            Do
                Application.DoEvents()
            Loop Until Now > timeOut
            data = myComPort.ReadExisting()
            myComPort.DiscardInBuffer()
            data = ""
            myComPort.DtrEnable = True
            RadioButton1.Enabled = True
            RadioButton1.Checked = True

        End If
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        If InputBox("Are you sure you would like to clear the database, please note that this can not be undone." & Chr(13) & "Please type 'yes' or 'no'.", "Clear Database", "no") = "yes" Then
            grid.Rows.Clear()

            Try
                cn = New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + RFID_Reader.My.Application.Info.DirectoryPath() + "/log.mdb;Persist Security Info=False")
                cn.Open()

                str = "delete * from table1"
                'string stores the command and CInt is used to convert number to string
                cmd = New OleDbCommand(str, cn)
                icount = cmd.ExecuteNonQuery
                'MessageBox.Show(icount)
                'displays number of records inserted
            Catch e2 As Exception
                MessageBox.Show(e2.ToString)
            End Try
            cn.Close()
        End If
    End Sub

    Private Sub grid_CellContentClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles grid.CellContentClick

    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub grid_CellEndEdit(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles grid.CellEndEdit
        Dim colName As String = ""
        If e.ColumnIndex() = 1 Then
            colName = "F_Name"
        ElseIf e.ColumnIndex() = 2 Then
            colName = "L_Name"
        End If
        Try
            cn = New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + RFID_Reader.My.Application.Info.DirectoryPath() + "/log.mdb;Persist Security Info=False")
            cn.Open()

            str = "update table1 SET " & colName & " = '" & grid.Rows.Item(e.RowIndex()).Cells.Item(e.ColumnIndex()).Value & "' where Tag = '" & grid.Rows.Item(e.RowIndex()).Cells.Item(0).Value & "'"
            'string stores the command and CInt is used to convert number to string
            cmd = New OleDbCommand(str, cn)
            icount = cmd.ExecuteNonQuery
            'MessageBox.Show(icount)
            'displays number of records inserted
        Catch e2 As Exception
            MessageBox.Show(e2.ToString)
        End Try
        cn.Close()
    End Sub
End Class
